#include <StandardCplusplus.h>
#include <string>

//#define enA 9
#define in1 7  //sterring
#define in2 8  //steering
//#define enB 10
#define in3 5  //pwm-throtle
#define in4 6  //pwm-throtle

int xAxis, yAxis;
int  x = 0;
int  y = 0;
std::string t;

int motorSpeedA = 0;
int motorSpeedB = 0;

void setup() {
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  
  Serial.begin(9600); // Default communication rate of the Bluetooth module
  
}

void loop() {
  // Default value - no movement when the Joystick stays in the center
  xAxis = 510;
  yAxis = 510;

  // Read the incoming data from the Smartphone Android App
  while (Serial.available() >= 2) {
    t = Serial.read();
    delay(10);
  }



  
  delay(10);
  
  // Makes sure we receive corrent values
  if (x > 60 & x < 220) {
    xAxis = map(x, 220, 60, 1023, 0); // Convert the smartphone X and Y values to 0 - 1023 range, suitable motor for the motor control code below
  }
  if (y > 60 & y < 220) {
    yAxis = map(y, 220, 60, 0, 1023);
  }

  // Y-axis used for forward and backward control
  if (yAxis < 490) {
    motorSpeedB = map(yAxis, 490, 0, 0, 255);
    // Set Motor B backward
    analogWrite(in3, motorSpeedB);
    digitalWrite(in4, LOW);
    // Convert the declining Y-axis readings for going backward from 470 to 0 into 0 to 255 value for the PWM signal for increasing the motor speed

  }
  else if (yAxis > 530) {
    // Set Motor A forward
    motorSpeedB = map(yAxis, 530, 1024, 0, 255);
    // Set Motor B forward
    digitalWrite(in3, LOW);
    analogWrite(in4, motorSpeedB);
  }
  // If joystick stays in middle the motors are not moving
  else {
    digitalWrite(in3, HIGH);
    digitalWrite(in4, HIGH);
  }

  // X-axis used for left and right control(not sure when between 470-550)
  if (xAxis < 470) {
     
    digitalWrite(in1, HIGH);
    digitalWrite(in2, LOW);
  }
  if (xAxis > 550) {
    digitalWrite(in1, LOW);
    digitalWrite(in2, HIGH);
  }
  // Prevent buzzing at low speeds (Adjust according to your motors. My motors couldn't start moving if PWM value was below value of 70)
  if (motorSpeedA < 70) {
    motorSpeedA = 0;
  }
  if (motorSpeedB < 70) {
    motorSpeedB = 0;
  }
}
